<?php 
/*
--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
- Attenzione!!! Il servizio non è mai attivo dalle 00.00 alle 04.00 

- La best practice per il collegamento a FattureAmazon è quella di pianificare a partire dalle ore 04.00 una sola esecuzione giornaliera 
  per recuperare tutti i documenti del giorno precedente;

- Formato output UTF-8
--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
*/

	//-----------------------------------------------------------
	// esempio richiesta documenti in data: AAAA-MM-GG 
	//-----------------------------------------------------------
	$yesterday = (new DateTime('yesterday'))->format('Y-m-d');

	$data = Service($yesterday); // return csv documenti richiesti 

	//-------------------------------------
	// scrittura su file .csv
	//-------------------------------------
	$file = fopen('doc.csv', 'w');
	fwrite($file, $data);
	fclose($file);

	//-------------------------------------
	// visualizzazione
	//-------------------------------------
	echo $data;
	
	exit;

	//-----------------------------------------------------------
	// Service: richiesta documenti in data: AAAA-MM-GG 
	//-----------------------------------------------------------
	// Server Response Codes	
	// 400 Bad Request
	// 401 Unauthorized
	// 402 Quota Exceeded: requested resource min 60 seconds  
	// 403 service currently not available  
	//-----------------------------------------------------------
	function Service($date)
	{
	 
//		$url = "https://www.fattureamazon.it/api/webservice_20240227.php?usr=A1YWTPQUNQHLN3&psw=bbd428cf-9dba-4ce1-992b-ffac1fc337dc&dat=" . $date;
		$url = "https://www.fattureamazon.it/api/webservice_20240227_sandbox.php?usr=A1YWTPQUNQHLN3&psw=bbd428cf-9dba-4ce1-992b-ffac1fc337dc&dat=" . $date;

		
		// init the request, set various options, and send it
		$ch = curl_init();

		curl_setopt_array($ch, [
			CURLOPT_URL => $url,
			CURLOPT_RETURNTRANSFER => true,
			CURLOPT_POST => true,
			CURLOPT_SSL_VERIFYHOST => 0,
			CURLOPT_SSL_VERIFYPEER=> 0,	
			CURLOPT_HTTPHEADER => ["Content-Type: application/x-www-form-urlencoded"]
		]);

		// get return
		$csv = curl_exec($ch);

		// close the request
		curl_close($ch);

		// output csv
		return $csv;
	}

?>
	
	
	